package backend

import (
	"context"

	"google.golang.org/grpc"
)

type BackendClient interface {
	Exec(ctx context.Context, in *BackendClientInput, opts ...grpc.CallOption) (*BackendClientOutput, error)
}

type BackendClientInput struct {
	Target string
	Method string
	Params []string
}

type BackendClientOutput struct {
	Result string
}

type PooledClient interface {
	Exec(ctx context.Context, target string, method string, params []string) (string, error)
	Close()
}
